Index: c/src/ada-tests/tmtests/tm02/tmtest.adb
===================================================================
--- c/src/ada-tests/tmtests/tm02/tmtest.adb	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
+++ c/src/ada-tests/tmtests/tm02/tmtest.adb	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
@@ -0,0 +1,208 @@
+--
+--  TMTEST / BODY
+--
+--  DESCRIPTION:
+--
+--  This package is the implementation of Test 2 of the RTEMS
+--  Timing Test Suite.
+--
+--  DEPENDENCIES: 
+--
+--  
+--
+--  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+--  On-Line Applications Research Corporation (OAR).
+--  All rights assigned to U.S. Government, 1994.
+--
+--  This material may be reproduced by or for the U.S. Government pursuant
+--  to the copyright license under the clause at DFARS 252.227-7013.  This
+--  notice must appear in all copies of this file and its derivatives.
+--
+--  tmtest.adb,v 1.3 1995/07/12 19:43:05 joel Exp
+--
+
+with INTERFACES; use INTERFACES;
+with RTEMS;
+with RTEMS_CALLING_OVERHEAD;
+with TEST_SUPPORT;
+with TEXT_IO;
+with TIME_TEST_SUPPORT;
+with UNSIGNED32_IO;
+
+package body TMTEST is
+
+--PAGE
+-- 
+--  INIT
+--
+
+   procedure INIT (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      STATUS : RTEMS.STATUS_CODES;
+   begin
+
+      TEXT_IO.NEW_LINE( 2 );
+      TEXT_IO.PUT_LINE( "*** TIME TEST 2 ***" );
+
+      TMTEST.TEST_INIT;
+
+      RTEMS.TASK_DELETE( RTEMS.SELF, STATUS );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_DELETE OF SELF" );
+
+   end INIT;
+
+--PAGE
+-- 
+--  TEST_INIT
+--
+
+   procedure TEST_INIT is
+      PRIORITY : RTEMS.TASK_PRIORITY;
+      INDEX    : RTEMS.UNSIGNED32;
+      HIGH_ID  : RTEMS.ID;
+      LOW_ID   : RTEMS.ID;
+      TASK_ID  : RTEMS.ID;
+      STATUS   : RTEMS.STATUS_CODES;
+   begin
+
+      PRIORITY := 5;
+
+      RTEMS.TASK_CREATE( 
+         RTEMS.BUILD_NAME( 'H', 'I', 'G', 'H' ),
+         PRIORITY, 
+         1024, 
+         RTEMS.DEFAULT_MODES,
+         RTEMS.DEFAULT_ATTRIBUTES,
+         HIGH_ID,
+         STATUS
+      );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_CREATE OF HIGH TASK" );
+
+      PRIORITY := PRIORITY + 1;
+
+      RTEMS.TASK_START( 
+         HIGH_ID, 
+         TMTEST.HIGH_TASK'ACCESS, 
+         0, 
+         STATUS 
+      );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_START OF HIGH TASK" );
+
+      for INDEX in 2 .. TIME_TEST_SUPPORT.OPERATION_COUNT
+      loop
+
+         RTEMS.TASK_CREATE( 
+            RTEMS.BUILD_NAME( 'M', 'I', 'D', ' ' ),
+            PRIORITY, 
+            1024, 
+            RTEMS.DEFAULT_MODES,
+            RTEMS.DEFAULT_ATTRIBUTES,
+            TASK_ID,
+            STATUS
+         );
+         TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_CREATE MIDDLE" );
+
+         PRIORITY := PRIORITY + 1;
+
+         RTEMS.TASK_START( 
+            TASK_ID, 
+            TMTEST.MIDDLE_TASKS'ACCESS, 
+            0, 
+            STATUS 
+         );
+         TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_START MIDDLE" );
+
+      end loop;
+
+      RTEMS.TASK_CREATE( 
+         RTEMS.BUILD_NAME( 'L', 'O', 'W', ' ' ),
+         PRIORITY, 
+         2048, 
+         RTEMS.DEFAULT_MODES,
+         RTEMS.DEFAULT_ATTRIBUTES,
+         LOW_ID,
+         STATUS
+      );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_CREATE OF LOW TASK" );
+
+      RTEMS.TASK_START( LOW_ID, TMTEST.LOW_TASK'ACCESS, 0, STATUS );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_START OF LOW TASK" );
+
+      RTEMS.SEMAPHORE_CREATE(
+         RTEMS.BUILD_NAME( 'S', 'M', '1', ' ' ),
+         0,
+         RTEMS.DEFAULT_ATTRIBUTES,
+         TMTEST.SEMAPHORE_ID,
+         STATUS
+      );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "SEMAPHORE_CREATE OF SM1" );
+
+   end TEST_INIT;
+
+--PAGE
+-- 
+--  HIGH_TASK
+--
+
+   procedure HIGH_TASK (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      STATUS                   : RTEMS.STATUS_CODES;
+   begin
+
+      TIMER_DRIVER.INITIALIZE;
+      RTEMS.SEMAPHORE_OBTAIN(
+         TMTEST.SEMAPHORE_ID,
+         RTEMS.DEFAULT_OPTIONS,
+         RTEMS.NO_TIMEOUT,
+         STATUS
+      );
+
+   end HIGH_TASK;
+
+--PAGE
+-- 
+--  MIDDLE_TASKS
+--
+
+   procedure MIDDLE_TASKS (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      STATUS                   : RTEMS.STATUS_CODES;
+   begin
+
+      RTEMS.SEMAPHORE_OBTAIN(
+         TMTEST.SEMAPHORE_ID,
+         RTEMS.DEFAULT_OPTIONS,
+         RTEMS.NO_TIMEOUT,
+         STATUS
+      );
+
+   end MIDDLE_TASKS;
+
+--PAGE
+-- 
+--  LOW_TASK
+--
+
+   procedure LOW_TASK (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      STATUS                   : RTEMS.STATUS_CODES;
+   begin
+
+      TMTEST.END_TIME := TIMER_DRIVER.READ_TIMER;
+      TIME_TEST_SUPPORT.PUT_TIME( 
+         "SEMAPHORE_OBTAIN (blocking)", 
+         TMTEST.END_TIME, 
+         TIME_TEST_SUPPORT.OPERATION_COUNT, 
+         0,
+         RTEMS_CALLING_OVERHEAD.SEMAPHORE_OBTAIN 
+      );
+
+      RTEMS.SHUTDOWN_EXECUTIVE( 0 );
+
+   end LOW_TASK;
+
+end TMTEST;
Index: c/src/ada-tests/tmtests/tm02/tmtest.ads
===================================================================
--- c/src/ada-tests/tmtests/tm02/tmtest.ads	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
+++ c/src/ada-tests/tmtests/tm02/tmtest.ads	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
@@ -0,0 +1,141 @@
+--
+--  TMTEST / SPECIFICATION
+--
+--  DESCRIPTION:
+--
+--  This package is the specification for Test 2 of the RTEMS
+--  Timing Test Suite.
+--
+--  DEPENDENCIES: 
+--
+--  
+--
+--  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+--  On-Line Applications Research Corporation (OAR).
+--  All rights assigned to U.S. Government, 1994.
+--
+--  This material may be reproduced by or for the U.S. Government pursuant
+--  to the copyright license under the clause at DFARS 252.227-7013.  This
+--  notice must appear in all copies of this file and its derivatives.
+--
+--  tmtest.ads,v 1.3 1995/07/12 19:43:07 joel Exp
+--
+
+with TIMER_DRIVER;
+with RTEMS;
+
+package TMTEST is
+
+--
+--  The following is the ID of the semaphore used for timing operations.
+--
+
+   SEMAPHORE_ID : RTEMS.ID;
+
+--
+--  The following variable is set to the execution time returned
+--  by the timer.
+--
+
+   END_TIME  : RTEMS.UNSIGNED32;
+
+--
+--  INIT
+--
+--  DESCRIPTION:
+--
+--  This RTEMS task initializes the application.
+--
+
+   procedure INIT (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  TEST_INIT
+--
+--  DESCRIPTION:
+--
+--  This subprogram performs test initialization.
+--
+
+   procedure TEST_INIT;
+
+--
+--  HIGH_TASK
+--
+--  DESCRIPTION:
+--
+--  This RTEMS task starts the timer and performs a blocking 
+--  SEMAPHORE_OBTAIN.
+--
+
+   procedure HIGH_TASK (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  MIDDLE_TASKS
+--
+--  DESCRIPTION:
+--
+--  These RTEMS task start the timer and performs a blocking 
+--  SEMAPHORE_OBTAIN.
+--
+
+   procedure MIDDLE_TASKS (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  LOW_TASK
+--
+--  DESCRIPTION:
+--
+--  This RTEMS task stops the timer and reports the execution time for
+--  a blocking SEMAPHORE_OBTAIN.
+--
+
+   procedure LOW_TASK (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  This is the Initialization Tasks Table for this test.
+--
+
+   INITIALIZATION_TASKS : aliased RTEMS.INITIALIZATION_TASKS_TABLE( 1 .. 1 ) := 
+   (1=>
+     (
+       RTEMS.BUILD_NAME( 'U', 'I', '1', ' ' ),        -- task name
+       2048,                                          -- stack size
+       1,                                             -- priority
+       RTEMS.DEFAULT_ATTRIBUTES,                      -- attributes
+       TMTEST.INIT'ACCESS,                            -- entry point
+       RTEMS.NO_PREEMPT,                              -- initial mode
+       0                                              -- argument list
+     )
+   );
+
+--
+--  This is the Configuration Table for this test.
+--
+
+   CONFIGURATION : aliased RTEMS.CONFIGURATION_TABLE := (
+      RTEMS.NULL_ADDRESS,        -- will be replaced by BSP
+      256 * 1024,                -- executive RAM size
+      111,                       -- maximum # tasks
+      110,                       -- maximum # timers
+      101,                       -- maximum # semaphores
+      0,                         -- maximum # message queues
+      0,                         -- maximum # messages
+      0,                         -- maximum # partitions
+      0,                         -- maximum # regions
+      0,                         -- maximum # dp memory areas
+      0,                         -- maximum # periods
+      0,                         -- maximum # user extensions
+      RTEMS.MILLISECONDS_TO_MICROSECONDS(10), -- # us in a tick
+      0                          -- # ticks in a timeslice
+  );
+
+end TMTEST;
